import React from 'react'
import Paper from 'material-ui/Paper'

import Search from './search/Search'
import Result from './result/Result'

import MuiThemeProvider from 'material-ui/styles/MuiThemeProvider';
import getMuiTheme from 'material-ui/styles/getMuiTheme';

export default class NDExNetworkSearch extends React.Component {

  static defaultProps = {
    style: {
      width: '100%',
      height: '100%',
      overflow: 'hidden'
    },
    defaultQuery: "",
    theme: {},
    filters: [],
    visualizations: [],
    onLoad: () => {}
  }

  render() {
    var {
      theme,
      filters,
      networks,
      networkActions,
      visualizations,
      ...pluginProps
    } = this.props
    networkActions.search(this.props.defaultQuery)
    const muiTheme = getMuiTheme(theme)
    return (
      <MuiThemeProvider muiTheme={muiTheme}>
        <div style={this.props.style}>
            <Search
              filters={filters}
              networkActions={networkActions}
              defaultQuery={this.props.defaultQuery}
            />
           <Result
              visualizations={visualizations}
              networks={networks}
              { ...pluginProps}
            />
        </div>
      </MuiThemeProvider>
    )
  }

}
